/**
  Generated Main Source File

  Company:
    Microchip Technology Inc.

  File Name:
    main.c

  Summary:
    This is the main file generated using MPLAB(c) Code Configurator

  Description:
    This header file provides implementations for driver APIs for all modules selected in the GUI.
    Generation Information :
        Product Revision  :  MPLAB(c) Code Configurator - 4.15
        Device            :  PIC16F1619
        Driver Version    :  2.00
    The generated drivers are tested against the following:
        Compiler          :  XC8 1.35
        MPLAB             :  MPLAB X 3.40
 */

/*
    (c) 2016 Microchip Technology Inc. and its subsidiaries. You may use this
    software and any derivatives exclusively with Microchip products.

    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY IMPLIED
    WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS FOR A
    PARTICULAR PURPOSE, OR ITS INTERACTION WITH MICROCHIP PRODUCTS, COMBINATION
    WITH ANY OTHER PRODUCTS, OR USE IN ANY APPLICATION.

    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE,
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP HAS
    BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO THE
    FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL CLAIMS IN
    ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT OF FEES, IF ANY,
    THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS SOFTWARE.

    MICROCHIP PROVIDES THIS SOFTWARE CONDITIONALLY UPON YOUR ACCEPTANCE OF THESE
    TERMS.
 */

#include "mcc_generated_files/mcc.h"
#include <xc.h>
#include <stdio.h>
#include "MRF24J40.h"

//void putch(unsigned char byte)
//{
//    TXSTA=0x26;
//    RCSTAbits.SPEN=1;
//    TXREG=byte;
//    while(!TXIF)continue;
//    TXIF=0;
//}

UINT8 txPayload[TX_PAYLOAD_SIZE]; // TX payload buffer

// inits Tx structure for simple point-to-point connection between a single pair of devices who both use the same address
// after calling this, you can send packets by just filling out:
// txPayload[] with payload and
// Tx.payloadLength,
// then calling RadioTXPacket()

void RadioInitP2P(void) {
    Tx.frameType = PACKET_TYPE_DATA;
    Tx.securityEnabled = 0;
    Tx.framePending = 0;
    Tx.ackRequest = 1;
    Tx.panIDcomp = 1;
    Tx.dstAddrMode = SHORT_ADDR_FIELD;
    Tx.frameVersion = 0;
    Tx.srcAddrMode = NO_ADDR_FIELD;
    Tx.dstPANID = RadioStatus.MyPANID;
    Tx.dstAddr = RadioStatus.MyShortAddress;
    Tx.payload = txPayload;
}

void intToLeds(int in) {
    //    ledD4_LAT LSB
    //    ledD6_LAT 
    //    ledD7_LAT MSB
    ledD4_SetLow();
//    ledD6_SetLow();
    ledD7_SetLow();
    if (in & 0b0001)
        ledD4_SetHigh();
//    if (in & 0b0010)
//        ledD6_SetHigh();
    if (in & 0b0100)
        ledD7_SetHigh();
}


#define DEMO 0
#define TRANSMITTER 1
#define RECEIVER 2

#define TEST 3
#define MODE 1

/*
                         Main application
 */
void main(void) {
    // initialize the device
    SYSTEM_Initialize();
    printf("main\r\n");
    if(MODE == TEST){
        printf("Exchange..\r\n");
//        highWrite(SLPCON0, 2);
//        highWrite(RFCON0, 0x03);
        testMRF();
//          SPI_Exchange8bit(5);
//          __delay_ms(20);
//          SPI_Exchange8bit(10);
//          __delay_ms(20);
//          SPI_Exchange8bit(15);
//          __delay_ms(20);
//          __delay_us(20);
//        lowRead2(INTSTAT);
//        lowWrite2(INTSTAT, 0x00);
        __delay_ms(5000);
        return;
    }
    
    INTERRUPT_GlobalInterruptEnable();
    INTERRUPT_PeripheralInterruptEnable();
    
    INT_SetInterruptHandler(handleZigbeeInterrupt);
    
    int mainCounter = 0;
    printf("\r\n\nMain %d\r\n\n", MODE);
    // testing uart
    while (MODE == DEMO) {
        printf("Hello %d\r\n", mainCounter);
        mainCounter++;
        ledD7_Toggle();
        __delay_ms(2000);
    }

//    zigRESET_SetLow();
//    __delay_ms(500);
//    zigRESET_SetHigh();
//    __delay_ms(200);


    // When using interrupts, you need to set the Global and Peripheral Interrupt Enable bits
    // Use the following macros to:

    // Enable the Global Interrupts
    //INTERRUPT_GlobalInterruptEnable();

    // Enable the Peripheral Interrupts
    //INTERRUPT_PeripheralInterruptEnable();

    // Disable the Global Interrupts
    //INTERRUPT_GlobalInterruptDisable();

    // Disable the Peripheral Interrupts
    //INTERRUPT_PeripheralInterruptDisable();


    RadioInit();
    
    RadioInitP2P();
    printf("loop time\r\n");
    
    UINT8 loopCounter = 0;
    UINT8 lastFrameNumber;
    while (1) {

        if (loopCounter >= 8) {
            loopCounter = 0;
        }
        //        intToLeds(loopCounter);

        if (MODE == RECEIVER) {
//            printf("...receiver loop %d...\r\n",mainCounter);
            while (RadioRXPacket()) {
                    printf("RadioRXPacket:%u\r\n",Rx.payloadLength);
                    Rx.payload[Rx.payloadLength] = 0;				// put terminating null on received payload
                    printf("\t%s\r\n", Rx.payload);						// print payload as an ASCII string
                if (Rx.frameNumber != lastFrameNumber) // skip duplicate packets (Usually because far-end missed my ACK)
                {
                    lastFrameNumber = Rx.frameNumber;

//                    UINT8 received = Rx.payload[0];
//                    printf("## %d\r\n", received);
                    
                    if (MODE == RECEIVER) {
//                        intToLeds(received);
                    }
                    //				Rx.payload[Rx.payloadLength] = 0;				// put terminating null on received payload
                    //				printf("%s", Rx.payload);						// print payload as an ASCII string
                }
                else{
//                    UINT8 received = Rx.payload[0];
//                    printf("## same %d\r\n", received);
                }
                RadioDiscardPacket();
            }
        } else if (MODE == TRANSMITTER) {
            printf("...transmitter loop %d...\r\n",mainCounter);
            //            Tx.payload[0] = mainCounter;
//            Tx.payloadLength = 1;
            Tx.payloadLength = sprintf(Tx.payload, "Transmission#%d",mainCounter);
            RadioTXPacket();
//            ledD7_Toggle();
            __delay_ms(2000);
        }
        mainCounter++;
        loopCounter++;
        
    }
}

/**
 End of File
 */