/**
  @Generated Pin Manager Header File

  @Company:
    Microchip Technology Inc.

  @File Name:
    pin_manager.h

  @Summary:
    This is the Pin Manager file generated using MPLAB(c) Code Configurator

  @Description:
    This header file provides implementations for pin APIs for all pins selected in the GUI.
    Generation Information :
        Product Revision  :  MPLAB(c) Code Configurator - 4.15
        Device            :  PIC16F1619
        Version           :  1.01
    The generated drivers are tested against the following:
        Compiler          :  XC8 1.35
        MPLAB             :  MPLAB X 3.40

    Copyright (c) 2013 - 2015 released Microchip Technology Inc.  All rights reserved.

    Microchip licenses to you the right to use, modify, copy and distribute
    Software only when embedded on a Microchip microcontroller or digital signal
    controller that is integrated into your product or third party product
    (pursuant to the sublicense terms in the accompanying license agreement).

    You should refer to the license agreement accompanying this Software for
    additional information regarding your rights and obligations.

    SOFTWARE AND DOCUMENTATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND,
    EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION, ANY WARRANTY OF
    MERCHANTABILITY, TITLE, NON-INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE.
    IN NO EVENT SHALL MICROCHIP OR ITS LICENSORS BE LIABLE OR OBLIGATED UNDER
    CONTRACT, NEGLIGENCE, STRICT LIABILITY, CONTRIBUTION, BREACH OF WARRANTY, OR
    OTHER LEGAL EQUITABLE THEORY ANY DIRECT OR INDIRECT DAMAGES OR EXPENSES
    INCLUDING BUT NOT LIMITED TO ANY INCIDENTAL, SPECIAL, INDIRECT, PUNITIVE OR
    CONSEQUENTIAL DAMAGES, LOST PROFITS OR LOST DATA, COST OF PROCUREMENT OF
    SUBSTITUTE GOODS, TECHNOLOGY, SERVICES, OR ANY CLAIMS BY THIRD PARTIES
    (INCLUDING BUT NOT LIMITED TO ANY DEFENSE THEREOF), OR OTHER SIMILAR COSTS.

*/


#ifndef PIN_MANAGER_H
#define PIN_MANAGER_H

#define INPUT   1
#define OUTPUT  0

#define HIGH    1
#define LOW     0

#define ANALOG      1
#define DIGITAL     0

#define PULL_UP_ENABLED      1
#define PULL_UP_DISABLED     0

// get/set ledD5 aliases
#define ledD5_TRIS               TRISAbits.TRISA1
#define ledD5_LAT                LATAbits.LATA1
#define ledD5_PORT               PORTAbits.RA1
#define ledD5_WPU                WPUAbits.WPUA1
#define ledD5_OD                ODCONAbits.ODA1
#define ledD5_ANS                ANSELAbits.ANSA1
#define ledD5_SetHigh()            do { LATAbits.LATA1 = 1; } while(0)
#define ledD5_SetLow()             do { LATAbits.LATA1 = 0; } while(0)
#define ledD5_Toggle()             do { LATAbits.LATA1 = ~LATAbits.LATA1; } while(0)
#define ledD5_GetValue()           PORTAbits.RA1
#define ledD5_SetDigitalInput()    do { TRISAbits.TRISA1 = 1; } while(0)
#define ledD5_SetDigitalOutput()   do { TRISAbits.TRISA1 = 0; } while(0)
#define ledD5_SetPullup()      do { WPUAbits.WPUA1 = 1; } while(0)
#define ledD5_ResetPullup()    do { WPUAbits.WPUA1 = 0; } while(0)
#define ledD5_SetPushPull()    do { ODCONAbits.ODA1 = 1; } while(0)
#define ledD5_SetOpenDrain()   do { ODCONAbits.ODA1 = 0; } while(0)
#define ledD5_SetAnalogMode()  do { ANSELAbits.ANSA1 = 1; } while(0)
#define ledD5_SetDigitalMode() do { ANSELAbits.ANSA1 = 0; } while(0)

// get/set ledD4 aliases
#define ledD4_TRIS               TRISAbits.TRISA5
#define ledD4_LAT                LATAbits.LATA5
#define ledD4_PORT               PORTAbits.RA5
#define ledD4_WPU                WPUAbits.WPUA5
#define ledD4_OD                ODCONAbits.ODA5
#define ledD4_SetHigh()            do { LATAbits.LATA5 = 1; } while(0)
#define ledD4_SetLow()             do { LATAbits.LATA5 = 0; } while(0)
#define ledD4_Toggle()             do { LATAbits.LATA5 = ~LATAbits.LATA5; } while(0)
#define ledD4_GetValue()           PORTAbits.RA5
#define ledD4_SetDigitalInput()    do { TRISAbits.TRISA5 = 1; } while(0)
#define ledD4_SetDigitalOutput()   do { TRISAbits.TRISA5 = 0; } while(0)
#define ledD4_SetPullup()      do { WPUAbits.WPUA5 = 1; } while(0)
#define ledD4_ResetPullup()    do { WPUAbits.WPUA5 = 0; } while(0)
#define ledD4_SetPushPull()    do { ODCONAbits.ODA5 = 1; } while(0)
#define ledD4_SetOpenDrain()   do { ODCONAbits.ODA5 = 0; } while(0)

// get/set RB5 procedures
#define RB5_SetHigh()    do { LATBbits.LATB5 = 1; } while(0)
#define RB5_SetLow()   do { LATBbits.LATB5 = 0; } while(0)
#define RB5_Toggle()   do { LATBbits.LATB5 = ~LATBbits.LATB5; } while(0)
#define RB5_GetValue()         PORTBbits.RB5
#define RB5_SetDigitalInput()   do { TRISBbits.TRISB5 = 1; } while(0)
#define RB5_SetDigitalOutput()  do { TRISBbits.TRISB5 = 0; } while(0)
#define RB5_SetPullup()     do { WPUBbits.WPUB5 = 1; } while(0)
#define RB5_ResetPullup()   do { WPUBbits.WPUB5 = 0; } while(0)
#define RB5_SetAnalogMode() do { ANSELBbits.ANSB5 = 1; } while(0)
#define RB5_SetDigitalMode()do { ANSELBbits.ANSB5 = 0; } while(0)

// get/set RB6 procedures
#define RB6_SetHigh()    do { LATBbits.LATB6 = 1; } while(0)
#define RB6_SetLow()   do { LATBbits.LATB6 = 0; } while(0)
#define RB6_Toggle()   do { LATBbits.LATB6 = ~LATBbits.LATB6; } while(0)
#define RB6_GetValue()         PORTBbits.RB6
#define RB6_SetDigitalInput()   do { TRISBbits.TRISB6 = 1; } while(0)
#define RB6_SetDigitalOutput()  do { TRISBbits.TRISB6 = 0; } while(0)
#define RB6_SetPullup()     do { WPUBbits.WPUB6 = 1; } while(0)
#define RB6_ResetPullup()   do { WPUBbits.WPUB6 = 0; } while(0)
#define RB6_SetAnalogMode() do { ANSELBbits.ANSB6 = 1; } while(0)
#define RB6_SetDigitalMode()do { ANSELBbits.ANSB6 = 0; } while(0)

// get/set RB7 procedures
#define RB7_SetHigh()    do { LATBbits.LATB7 = 1; } while(0)
#define RB7_SetLow()   do { LATBbits.LATB7 = 0; } while(0)
#define RB7_Toggle()   do { LATBbits.LATB7 = ~LATBbits.LATB7; } while(0)
#define RB7_GetValue()         PORTBbits.RB7
#define RB7_SetDigitalInput()   do { TRISBbits.TRISB7 = 1; } while(0)
#define RB7_SetDigitalOutput()  do { TRISBbits.TRISB7 = 0; } while(0)
#define RB7_SetPullup()     do { WPUBbits.WPUB7 = 1; } while(0)
#define RB7_ResetPullup()   do { WPUBbits.WPUB7 = 0; } while(0)
#define RB7_SetAnalogMode() do { ANSELBbits.ANSB7 = 1; } while(0)
#define RB7_SetDigitalMode()do { ANSELBbits.ANSB7 = 0; } while(0)

// get/set RC0 procedures
#define RC0_SetHigh()    do { LATCbits.LATC0 = 1; } while(0)
#define RC0_SetLow()   do { LATCbits.LATC0 = 0; } while(0)
#define RC0_Toggle()   do { LATCbits.LATC0 = ~LATCbits.LATC0; } while(0)
#define RC0_GetValue()         PORTCbits.RC0
#define RC0_SetDigitalInput()   do { TRISCbits.TRISC0 = 1; } while(0)
#define RC0_SetDigitalOutput()  do { TRISCbits.TRISC0 = 0; } while(0)
#define RC0_SetPullup()     do { WPUCbits.WPUC0 = 1; } while(0)
#define RC0_ResetPullup()   do { WPUCbits.WPUC0 = 0; } while(0)
#define RC0_SetAnalogMode() do { ANSELCbits.ANSC0 = 1; } while(0)
#define RC0_SetDigitalMode()do { ANSELCbits.ANSC0 = 0; } while(0)

// get/set RC2 procedures
#define RC2_SetHigh()    do { LATCbits.LATC2 = 1; } while(0)
#define RC2_SetLow()   do { LATCbits.LATC2 = 0; } while(0)
#define RC2_Toggle()   do { LATCbits.LATC2 = ~LATCbits.LATC2; } while(0)
#define RC2_GetValue()         PORTCbits.RC2
#define RC2_SetDigitalInput()   do { TRISCbits.TRISC2 = 1; } while(0)
#define RC2_SetDigitalOutput()  do { TRISCbits.TRISC2 = 0; } while(0)
#define RC2_SetPullup()     do { WPUCbits.WPUC2 = 1; } while(0)
#define RC2_ResetPullup()   do { WPUCbits.WPUC2 = 0; } while(0)
#define RC2_SetAnalogMode() do { ANSELCbits.ANSC2 = 1; } while(0)
#define RC2_SetDigitalMode()do { ANSELCbits.ANSC2 = 0; } while(0)

// get/set ledD7 aliases
#define ledD7_TRIS               TRISCbits.TRISC5
#define ledD7_LAT                LATCbits.LATC5
#define ledD7_PORT               PORTCbits.RC5
#define ledD7_WPU                WPUCbits.WPUC5
#define ledD7_OD                ODCONCbits.ODC5
#define ledD7_SetHigh()            do { LATCbits.LATC5 = 1; } while(0)
#define ledD7_SetLow()             do { LATCbits.LATC5 = 0; } while(0)
#define ledD7_Toggle()             do { LATCbits.LATC5 = ~LATCbits.LATC5; } while(0)
#define ledD7_GetValue()           PORTCbits.RC5
#define ledD7_SetDigitalInput()    do { TRISCbits.TRISC5 = 1; } while(0)
#define ledD7_SetDigitalOutput()   do { TRISCbits.TRISC5 = 0; } while(0)
#define ledD7_SetPullup()      do { WPUCbits.WPUC5 = 1; } while(0)
#define ledD7_ResetPullup()    do { WPUCbits.WPUC5 = 0; } while(0)
#define ledD7_SetPushPull()    do { ODCONCbits.ODC5 = 1; } while(0)
#define ledD7_SetOpenDrain()   do { ODCONCbits.ODC5 = 0; } while(0)

// get/set pinCS aliases
#define pinCS_TRIS               TRISCbits.TRISC7
#define pinCS_LAT                LATCbits.LATC7
#define pinCS_PORT               PORTCbits.RC7
#define pinCS_WPU                WPUCbits.WPUC7
#define pinCS_OD                ODCONCbits.ODC7
#define pinCS_ANS                ANSELCbits.ANSC7
#define pinCS_SetHigh()            do { LATCbits.LATC7 = 1; } while(0)
#define pinCS_SetLow()             do { LATCbits.LATC7 = 0; } while(0)
#define pinCS_Toggle()             do { LATCbits.LATC7 = ~LATCbits.LATC7; } while(0)
#define pinCS_GetValue()           PORTCbits.RC7
#define pinCS_SetDigitalInput()    do { TRISCbits.TRISC7 = 1; } while(0)
#define pinCS_SetDigitalOutput()   do { TRISCbits.TRISC7 = 0; } while(0)
#define pinCS_SetPullup()      do { WPUCbits.WPUC7 = 1; } while(0)
#define pinCS_ResetPullup()    do { WPUCbits.WPUC7 = 0; } while(0)
#define pinCS_SetPushPull()    do { ODCONCbits.ODC7 = 1; } while(0)
#define pinCS_SetOpenDrain()   do { ODCONCbits.ODC7 = 0; } while(0)
#define pinCS_SetAnalogMode()  do { ANSELCbits.ANSC7 = 1; } while(0)
#define pinCS_SetDigitalMode() do { ANSELCbits.ANSC7 = 0; } while(0)

/**
   @Param
    none
   @Returns
    none
   @Description
    GPIO and peripheral I/O initialization
   @Example
    PIN_MANAGER_Initialize();
 */
void PIN_MANAGER_Initialize (void);

/**
 * @Param
    none
 * @Returns
    none
 * @Description
    Interrupt on Change Handling routine
 * @Example
    PIN_MANAGER_IOC();
 */
void PIN_MANAGER_IOC(void);


/**
 * @Param
    none
 * @Returns
    none
 * @Description
    Interrupt on Change Handler for the IOCCF2 pin functionality
 * @Example
    IOCCF2_ISR();
 */
void IOCCF2_ISR(void);

/**
  @Summary
    Interrupt Handler Setter for IOCCF2 pin interrupt-on-change functionality

  @Description
    Allows selecting an interrupt handler for IOCCF2 at application runtime
    
  @Preconditions
    Pin Manager intializer called

  @Returns
    None.

  @Param
    InterruptHandler function pointer.

  @Example
    PIN_MANAGER_Initialize();
    IOCCF2_SetInterruptHandler(MyInterruptHandler);

*/
void IOCCF2_SetInterruptHandler(void* InterruptHandler);

/**
  @Summary
    Dynamic Interrupt Handler for IOCCF2 pin

  @Description
    This is a dynamic interrupt handler to be used together with the IOCCF2_SetInterruptHandler() method.
    This handler is called every time the IOCCF2 ISR is executed and allows any function to be registered at runtime.
    
  @Preconditions
    Pin Manager intializer called

  @Returns
    None.

  @Param
    None.

  @Example
    PIN_MANAGER_Initialize();
    IOCCF2_SetInterruptHandler(IOCCF2_InterruptHandler);

*/
extern void (*IOCCF2_InterruptHandler)(void);

/**
  @Summary
    Default Interrupt Handler for IOCCF2 pin

  @Description
    This is a predefined interrupt handler to be used together with the IOCCF2_SetInterruptHandler() method.
    This handler is called every time the IOCCF2 ISR is executed. 
    
  @Preconditions
    Pin Manager intializer called

  @Returns
    None.

  @Param
    None.

  @Example
    PIN_MANAGER_Initialize();
    IOCCF2_SetInterruptHandler(IOCCF2_DefaultInterruptHandler);

*/
void IOCCF2_DefaultInterruptHandler(void);



#endif // PIN_MANAGER_H
/**
 End of File
*/